//
// UCSD p-System filesystem in user space
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// you option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program. If not, see <http://www.gnu.org/licenses/>
//

#include <cstring>

#include <lib/rcstring/accumulator.h>


void
rcstring_accumulator::grow(size_t minimum_size)
{
    if (minimum_size <= maximum)
        return;
    size_t new_maximum = maximum;
    for (;;)
    {
        new_maximum = new_maximum * 2 + 16;
        if (minimum_size <= new_maximum)
            break;
    }
    char *new_buffer = new char [new_maximum];
    if (length)
        memcpy(new_buffer, buffer, length);
    delete [] buffer;
    buffer = new_buffer;
    maximum = new_maximum;
}
